
//  Etsikorvaa.java  Copyright (c) 2006 Kari Laitinen

//  http://www.naturalprogramming.com

//  2006-03-06  Tiedosto luotu.
//  2006-03-06  Viimeisin muutos.

//  Paras tapa tmn ohjelman suorittamiseksi on ajaa tt
//  komentorivi-ikkunassa jossa ohjelmalle voidaan sytt
//  komentoriviparametreja. Voi olla vaikeaa, ellei jopa mahdotonta,
//  antaa komentoriviparametreja silloin kun sit ajetaan
//  modernilla ohjelmakehitystykalulla kuten JCreatorilla tai
//  Eclipsell.

//  Tm ohjelma osaa kuitenkin pyyt kyttjlt tarvittavat
//  tiedot jos niit ei annettu komentorivilt.

import java.util.* ;  // ArrayList, Scanner, jne.
import java.io.* ;    // Luokat tiedostojen kasittelyyn.

class Etsikorvaa
{
   static void talleta_tekstirivit_tiedostoon(
                         ArrayList<String> annettu_taulukko_tekstiriveja,
                         String            annettu_tiedoston_nimi )
   {
      try
      {
         PrintWriter output_tiedosto  = 
                new PrintWriter( new FileWriter( annettu_tiedoston_nimi ) ) ;

         for ( int rivin_indeksi  =  0 ;
                   rivin_indeksi  <  annettu_taulukko_tekstiriveja.size() ;
                   rivin_indeksi  ++ )
         {
            output_tiedosto.println(
                      annettu_taulukko_tekstiriveja.get( rivin_indeksi ) ) ;
         }

         output_tiedosto.close() ;
      }
      catch ( IOException vangittu_io_poikkeus )
      {
         System.out.print( "\n\n Ei voi kirjoittaa tiedostoon \""
                        +  annettu_tiedoston_nimi  +  "\"\n" ) ;
      }
   }


   static void korvaa_stringi_tiedostossa( String  alkuperainen_tiedoston_nimi,
                                           String  korvattava_stringi,
                                           String  korvaava_stringi )
   {
      try
      {
         BufferedReader alkuperainen_tiedosto  =
           new BufferedReader( new FileReader( alkuperainen_tiedoston_nimi ) );
         ArrayList<String> alkuperaiset_tekstirivit = new ArrayList<String>() ;
         ArrayList<String> muutetut_tekstirivit = new ArrayList<String>() ;

         int  rivilaskuri  =  0 ;
         boolean tiedoston_loppu_kohdattu  =  false ;

         while ( tiedoston_loppu_kohdattu  ==  false )
         {
            String tekstirivi_tiedostosta  =  alkuperainen_tiedosto.readLine() ;

            if ( tekstirivi_tiedostosta  ==  null )
            {
               tiedoston_loppu_kohdattu  =  true ;
            }
            else
            {
               rivilaskuri  ++ ;
               alkuperaiset_tekstirivit.add( tekstirivi_tiedostosta ) ;

               if ( tekstirivi_tiedostosta.contains( korvattava_stringi ) )
               {
                  tekstirivi_tiedostosta  =
                          tekstirivi_tiedostosta.replace( korvattava_stringi,
                                                       korvaava_stringi ) ;

                  System.out.print( "\n \""  +  korvattava_stringi
                       +  "\" korvattiin stringilla \""  +  korvaava_stringi
                       +  "\" rivilla "  +  rivilaskuri  ) ;
               }

               muutetut_tekstirivit.add( tekstirivi_tiedostosta ) ;
            }
         }

         alkuperainen_tiedosto.close() ;

         String backup_tiedoston_nimi = alkuperainen_tiedoston_nimi + ".bak" ;

         talleta_tekstirivit_tiedostoon( alkuperaiset_tekstirivit,
                                   backup_tiedoston_nimi   ) ; 
         talleta_tekstirivit_tiedostoon( muutetut_tekstirivit,
                                   alkuperainen_tiedoston_nimi ) ;
      }
      catch ( FileNotFoundException vangittu_tiedostoa_ei_loydy_poikkeus )
      {
         System.out.print( "\n " + alkuperainen_tiedoston_nimi + " ei aukea.");
      }
      catch ( IOException  vangittu_io_poikkeus )
      {
         System.out.print( "\n Tiedostoa " + alkuperainen_tiedoston_nimi
                        +  " luettaessa sattui virhe." ) ;
      }
   }


   public static void main( String[] komentoriviparametrit )
   {
      Scanner nappaimisto = new Scanner( System.in ) ;

      String  kayttajan_antama_tiedoston_nimi ;
      String  korvattava_stringi ;
      String  korvaava_stringi ;

      if ( komentoriviparametrit.length  ==  3 )
      {
         kayttajan_antama_tiedoston_nimi  =  komentoriviparametrit[ 0 ] ;
         korvattava_stringi               =  komentoriviparametrit[ 1 ] ;
         korvaava_stringi                 =  komentoriviparametrit[ 2 ] ;
      }
      else
      {
         System.out.print( "\n Tama ohjelma muuttaa annetun stringin "
                        +  "\n tekstitiedostossa. Anna tiedoston nimi :  " ) ;

         kayttajan_antama_tiedoston_nimi  =  nappaimisto.nextLine() ;

         System.out.print( "\n Anna korvattava stringi: " ) ;
         korvattava_stringi    =  nappaimisto.nextLine() ;

         System.out.print( "\n Anna korvaava stringi:   " ) ;
         korvaava_stringi   =  nappaimisto.nextLine() ;
      }

      if ( korvattava_stringi.equals( "" )  ||
           korvattava_stringi.equals( korvaava_stringi ) )
      {
         System.out.print( "\n Ei voi muuttaa:  \"" + korvattava_stringi
              +  "\" ==> \""  +  korvaava_stringi  +  "\"\n\n" ) ;
      }
      else
      {
         korvaa_stringi_tiedostossa( kayttajan_antama_tiedoston_nimi,
                                     korvattava_stringi,
                                     korvaava_stringi ) ;
      }
   }
}



